/*----------------------------------------------------------------------*/
/*	                     rpg		*/
/*----------------------------------------------------------------------*/
#include	"sgl.h"
#include	"sega_sys.h"


#define		RBG0RB_CEL_ADR			(VDP2_VRAM_A0            )
#define		RBG0RB_MAP_ADR			(VDP2_VRAM_B0            )
#define		RBG0RB_COL_ADR			(VDP2_COLRAM    + 0x00200)
#define		RBG0RA_CEL_ADR			(RBG0RB_CEL_ADR + 0x06e80)
#define		RBG0RA_MAP_ADR			(RBG0RB_MAP_ADR + 0x02000)
#define		RBG0RA_COL_ADR			(RBG0RB_COL_ADR + 0x00200)
#define		RBG0_KTB_ADR			(VDP2_VRAM_A1            )
#define		RBG0_PRA_ADR			(VDP2_VRAM_A1   + 0x1fe00)
#define		RBG0_PRB_ADR			(RBG0_PRA_ADR   + 0x80   )
#define		BACK_COL_ADR			(VDP2_VRAM_A1   + 0x1fffe)
#define		PAD_NUM			13

static Uint16 pad_asign[] = {
	PER_DGT_KU,
	PER_DGT_KD,
	PER_DGT_KR,
	PER_DGT_KL,
	PER_DGT_TA,
	PER_DGT_TB,
	PER_DGT_TC,
	PER_DGT_ST,
	PER_DGT_TX,
	PER_DGT_TY,
	PER_DGT_TZ,
	PER_DGT_TR,
	PER_DGT_TL,
};


extern TEXTURE tex_spr[];
extern PICTURE pic_spr[];
extern FIXED playerpos[][XYZS];
extern FIXED groundpos[][XYZS];
extern FIXED wallpos[][XYZS];
extern SPR_ATTR attr[];
extern ANGLE angz[];


/*----------------------------------------------------------------------*/
static void set_sprite(PICTURE *pcptr , Uint32 NbPicture)
{
	TEXTURE *txptr;
 
	for(; NbPicture-- > 0; pcptr++){
		txptr = tex_spr + pcptr->texno;
		slDMACopy((void *)pcptr->pcsrc,
			(void *)(SpriteVRAM + ((txptr->CGadr) << 3)),
			(Uint32)((txptr->Hsize * txptr->Vsize * 4) >> (pcptr->cmode)));
	}
}

/*----------------------------------------------------------------------*/
static void disp_ground(int SpriteNo)
{
	
	//slDispSprite((FIXED *)stat[SpriteNo], (SPR_ATTR *)(&attr[SpriteNo].texno), DEGtoANG(0));
	slDispSprite((FIXED *)groundpos[SpriteNo], (SPR_ATTR *)(&attr[0].texno), DEGtoANG(0));
	
}

/*----------------------------------------------------------------------*/
static void disp_wall(int SpriteNo)
{
	
	//slDispSprite((FIXED *)stat[SpriteNo], (SPR_ATTR *)(&attr[SpriteNo].texno), DEGtoANG(0));
	slDispSprite((FIXED *)wallpos[SpriteNo], (SPR_ATTR *)(&attr[1].texno), DEGtoANG(0));
	
}

/*----------------------------------------------------------------------*/
static void disp_player(int SpriteNo)
{
	
	//slDispSprite((FIXED *)stat[SpriteNo], (SPR_ATTR *)(&attr[SpriteNo].texno), DEGtoANG(0));
	slDispSprite((FIXED *)playerpos[SpriteNo], (SPR_ATTR *)(&attr[2].texno), DEGtoANG(0));
	
}

/*----------------------------------------------------------------------*/
void ss_main(void)
{
	Uint16 data;
	Uint32 s,m;
	PerDigital	*pptr ;
    	Sint16	padp ;
	
	slInitSystem(TV_320x224,tex_spr,1);

	set_sprite(pic_spr,3);


	while(1) 
	{
		if(!Per_Connect1) return;
		data = Smpc_Peripheral[0].data;
		pptr = Smpc_Peripheral;
		padp = ~pptr->push;

		if((data & pad_asign[5])==0)			/* if B is pressed, restart */
		{
			
		}		

		if((data & pad_asign[0])==0)		/* si appuie en haut */
		{			
			//walk += toFIXED(1.0);
			playerpos[0][1] -= toFIXED(2.0);
			//UpdateSpritePosition();
			//PlayerWalkRight();
			MoveWorldV();
		}
		
		if((data & pad_asign[2])==0)		/* si appuie a droite */
		{
			//walk += toFIXED(1.0);
			/*for(s=0; s<54; s++ )
			{
				if((playerpos[0][0]>=groundpos[s][0]) & (playerpos[0][0]<=(groundpos[s][0]+toFIXED(16))))
				{
					playerpos[0][0] += toFIXED(2.0);
					break;			
				}
			}*/
			//UpdateSpritePosition();
			//PlayerWalkRight();			
			MoveWorldH();
		}	
	
		//affiche le sol
		for(s=0; s<135; s++ )
		{
			disp_ground(s);
		}
		
		//affiche les murs
		for(m=0; m<11; m++ )
		{
			disp_wall(m);
		}
		
		//affiche le perso
		disp_player(0);
		
				
		slPrintFX(groundpos[130][1], slLocate(25,20));
		slPrintFX(groundpos[132][1], slLocate(25,22));
		slPrintFX(toFIXED(s), slLocate(25,24));

		slSynch();
	} 
}

MoveWorldH()
{
	Sint16 i;
	
	for(i=0; i<135; i++ )
	{
		wallpos[i][0] += toFIXED(20.0);
	}
	
}

MoveWorldV()
{
	Sint16 i;
	
	for(i=0; i<135; i++ )
	{
		wallpos[i][1] += toFIXED(20.0);
	}
	
}
